var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toESM = (module2, isNodeMode) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", !isNodeMode && module2 && module2.__esModule ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);

// src/provider/credentials-handler.lambda.ts
var credentials_handler_lambda_exports = {};
__export(credentials_handler_lambda_exports, {
  handler: () => handler
});
var AWS = __toESM(require("aws-sdk"));

// src/provider/calculate-ses-smtp-password.ts
var import_buffer = require("buffer");
var import_crypto = require("crypto");
var sign = (key, message) => {
  const hmac = (0, import_crypto.createHmac)("sha256", import_buffer.Buffer.from(key.map((a) => a.charCodeAt(0)))).update(message);
  return hmac.digest("binary").toString().split("");
};
var calculateSesSmtpPassword = (secretAccessKey, region) => {
  const date = "11111111";
  const service = "ses";
  const terminal = "aws4_request";
  const message = "SendRawEmail";
  const version = [4];
  let signature = sign(`AWS4${secretAccessKey}`.split(""), date);
  signature = sign(signature, region);
  signature = sign(signature, service);
  signature = sign(signature, terminal);
  signature = sign(signature, message);
  const signatureAndVersion = version.slice();
  signature.forEach((a) => signatureAndVersion.push(a.charCodeAt(0)));
  return import_buffer.Buffer.from(signatureAndVersion).toString("base64");
};

// src/provider/credentials-handler.lambda.ts
async function handler(event) {
  const requestType = event.RequestType;
  console.log(`Request of type ${requestType} received`);
  if (requestType == "Create") {
    const username = event.ResourceProperties.UserName;
    const secretId = event.ResourceProperties.SecretId;
    const region = process.env.AWS_DEFAULT_REGION;
    const iam = new AWS.IAM();
    const secretsManager = new AWS.SecretsManager();
    const accessKey = await iam.createAccessKey({
      UserName: username
    }).promise();
    const accessKeyId = accessKey.AccessKey.AccessKeyId;
    const secretAccessKey = accessKey.AccessKey.SecretAccessKey;
    const smtpPassword = calculateSesSmtpPassword(secretAccessKey, region);
    await secretsManager.putSecretValue({
      SecretId: secretId,
      SecretString: JSON.stringify({
        ["username" /* USERNAME */]: username,
        ["password" /* PASSWORD */]: smtpPassword
      })
    }).promise();
    return __spreadProps(__spreadValues({}, event), {
      PhysicalResourceId: accessKeyId,
      Data: __spreadProps(__spreadValues({}, event.ResourceProperties), {
        AccessKeyId: accessKeyId
      })
    });
  }
  if (requestType == "Update") {
    console.log("Access key has already been provisioned, no operation to be performed");
  }
  if (requestType == "Delete") {
    console.log("No operation required, deletion of this resource is assumed to occur in conjunction with deletion of an IAM User and a SecretsManager Secret");
  }
  return __spreadProps(__spreadValues({}, event), {
    Data: __spreadValues({}, event.ResourceProperties)
  });
}
module.exports = __toCommonJS(credentials_handler_lambda_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  handler
});
